﻿
var dbPath = System.Gadget.path + "/files/stations.xml";
var xmlDoc = "";
var nameIX      = 0;
var genereIX    = 1;
var colorIX     = 2;
var mediaUrlIX  = 3;
var webIX       = 4;
var bookmarkIX  = 5;
var notesIX     = 6;
var cityIX      = 7;

/***********************************************************
 * load the Database
 ***********************************************************/
function createXMLdoc()
{
    xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
    xmlDoc.async = "false";
    xmlDoc.load(dbPath);  
    
    //convert to current version
    var node = xmlDoc.selectSingleNode("//root/stations[@version='3']");
    
    if(!node)
    {
        var stationsElement = xmlDoc.selectSingleNode("//root/stations");
        var newatt;
        newatt=xmlDoc.createAttribute("version");   
        newatt.value = "3";
        stationsElement.setAttributeNode(newatt);
      
        var stationElement = xmlDoc.getElementsByTagName("station");
        for (var i = 0; i < stationElement.length; i++)
        {
            var allAttributes = stationElement.item(i).attributes;
            var numberOfAttributes = allAttributes.length;
            if(numberOfAttributes < 8)
            {
                 newatt=xmlDoc.createAttribute("bookmark");
                newatt.value = "false";
                stationElement.item(i).setAttributeNode(newatt);
   
                newatt=xmlDoc.createAttribute("notes");
                newatt.value = "";
                stationElement.item(i).setAttributeNode(newatt);
   
                newatt=xmlDoc.createAttribute("city");
                newatt.value = "";
                stationElement.item(i).setAttributeNode(newatt);
            }
        }
        xmlDoc.save(dbPath);
    }     
}
/***********************************************************
 * select the generes from the database and load them
 * into the drop down menu
 ***********************************************************/
var generes = new Array();
function createGenereDD()
{
    /*-----------------------------------------------------
     * Clear the table of generes
     *-----------------------------------------------------*/
    generes.length = 0;
    /*-----------------------------------------------------
     * Loop thru the station elements and save all 
     * distinct geners
     *-----------------------------------------------------*/
    var stationsElement = xmlDoc.getElementsByTagName("station");
    for (var i = 0; i < stationsElement.length; i++)
    {
        if(!genereAlreadySaved(stationsElement.item(i).attributes(genereIX).value))
            generes.push(stationsElement.item(i).attributes(genereIX).value);    
    }
    /*-----------------------------------------------------
     * Sort the table
     *-----------------------------------------------------*/
    generes.sort();
    /*-----------------------------------------------------
     * Clear and reload the genereDD
     *-----------------------------------------------------*/
    document.all("generesDD").options.length=0;
    var optSelected = false;
    for (i = 0; i < generes.length; i++)
    {
        var optn = document.createElement("OPTION");
        optn.text = generes[i];
        optn.value = generes[i];
        document.all("generesDD").options.add(optn);
        if(generes[i] == System.Gadget.document.parentWindow.lastGenere)
        {
            document.all("generesDD").options[i].selected=true;
            optSelected = true;
        }
    }
    /*-----------------------------------------------------
     * settings
     *-----------------------------------------------------*/
    if((document.all("generesDD").options.length > 0) &&(!optSelected))
    {
        document.all("generesDD").options[0].selected=true;
        var selectedValue = document.all("generesDD").value;
        System.Gadget.Settings.write("lastGenere", selectedValue);
        System.Gadget.document.parentWindow.lastGenere = selectedValue;
    }
    
}
function genereAlreadySaved(genere)
{
    for (var i = 0; i < generes.length; i++)
    {
        if(generes[i] == genere)
        {
            return true;
        }
    }
    return false;
}
/***********************************************************
 * genereDD changed
 ***********************************************************/
function onchangeGenereDD()
{
   
    /*-----------------------------------------------------
     * Clear the table of generes
     *-----------------------------------------------------*/
    var selectedValue = document.all("generesDD").value;
    System.Gadget.Settings.write("lastGenere", selectedValue);
    System.Gadget.document.parentWindow.lastGenere = selectedValue;
    
    
   // System.Gadget.Settings.write("lastStation", null);
   // System.Gadget.document.parentWindow.lastStation = null;
   // System.Gadget.Settings.write("lastStream", null);
   // System.Gadget.document.parentWindow.lastStream = null;
   // System.Gadget.document.parentWindow.stationName.innerText = null;
    
    
    createStationDD();
}
/***********************************************************
 * select the stations for the selected genere from the 
 * database and load them into the drop down menu
 ***********************************************************/
var stations = new Array(); 
function createStationDD()
{
    /*-----------------------------------------------------
     * Clear the table of generes
     *-----------------------------------------------------*/
    stations.length = 0;
    /*-----------------------------------------------------
     * Loop thru the station elements and save all
     *-----------------------------------------------------*/
    var stationsElement = xmlDoc.getElementsByTagName("station");
    for (var i = 0; i < stationsElement.length; i++)
    {
        if(stationsElement.item(i).attributes(genereIX).value == System.Gadget.document.parentWindow.lastGenere)
        {
          
            var allAttributes = stationsElement.item(i).attributes;
            var numberOfAttributes = allAttributes.length;
            if(numberOfAttributes <= 5)
            {
                document.all("showMarkedBX").disabled = true; 
                stations.push(stationsElement.item(i).attributes(nameIX).value+"§"+stationsElement.item(i).attributes(mediaUrlIX).value);
            }    
            else
            {              
                if(
                (!document.all("showMarkedBX").checked) |
                ((document.all("showMarkedBX").checked)&&(stationsElement.item(i).attributes(bookmarkIX).value == "true"))
                )
                stations.push(stationsElement.item(i).attributes(nameIX).value+"§"+stationsElement.item(i).attributes(mediaUrlIX).value);
            }
        }   
    }
    /*-----------------------------------------------------
     * Sort the tablemediaUrlIX
     *-----------------------------------------------------*/
    stations.sort();
    
    /*-----------------------------------------------------
     * Clear and reload the dropdown
     *-----------------------------------------------------*/
    document.all("stationsDD").options.length=0;
    var optSelected = false;    
    for (i = 0; i < stations.length; i++)
    {
        var stationAttr = new Array();
        stationAttr = stations[i].split("§");
        var optn = document.createElement("OPTION");
        optn.text = stationAttr[0];
        optn.value = stations[i];
        document.all("stationsDD").options.add(optn);
        if(stationAttr[0] == System.Gadget.document.parentWindow.lastStation)
        {
            document.all("stationsDD").options[i].selected=true;
            System.Gadget.document.parentWindow.showButton.disabled = false;
            System.Gadget.document.parentWindow.powerButton.disabled = false;
            optSelected = true;
            
            if(System.Gadget.document.parentWindow.isRunning)
            {
                System.Gadget.document.parentWindow.MediaPlayer.Stop();
                System.Gadget.document.parentWindow.MediaPlayer.Open(System.Gadget.document.parentWindow.lastStream);
                System.Gadget.document.parentWindow.MediaPlayer.Play();
            }
        }
    }
    /*-----------------------------------------------------
     * settings
     *-----------------------------------------------------*/
    if((document.all("stationsDD").options.length>0)&&(!optSelected))
    {
        document.all("stationsDD").options[0].selected=true;
        onchangeStationDD();
    }  
    
}
/***********************************************************
 * stationDD changed
 ***********************************************************/
function onchangeStationDD()
{
    var selectedValue = document.all("stationsDD").value;
    var stationAttr = new Array();
    stationAttr = selectedValue.split("§");
    System.Gadget.Settings.write("lastStation", stationAttr[0]);
    System.Gadget.document.parentWindow.lastStation = stationAttr[0];
    System.Gadget.Settings.write("lastStream", stationAttr[1]);
    System.Gadget.document.parentWindow.lastStream = stationAttr[1];
    System.Gadget.document.parentWindow.stationName.innerText = stationAttr[0];
    
    System.Gadget.document.parentWindow.showButton.disabled = false;
    System.Gadget.document.parentWindow.powerButton.disabled = false;
    
    if(System.Gadget.document.parentWindow.isRunning)
    {
        System.Gadget.document.parentWindow.MediaPlayer.Stop();
        System.Gadget.document.parentWindow.MediaPlayer.Open(System.Gadget.document.parentWindow.lastStream);
        System.Gadget.document.parentWindow.MediaPlayer.Play();
    }
    
    
}
/***********************************************************
 * show marked only clicked
 ***********************************************************/
function onclickMarkedBX()
{
    if(document.all("showMarkedBX").checked)
    {
        System.Gadget.Settings.write("showMarkedOnly", true);
        System.Gadget.document.parentWindow.showMarkedOnly = true;
    }
    else
    {
        System.Gadget.Settings.write("showMarkedOnly", false);
        System.Gadget.document.parentWindow.showMarkedOnly = false;
    }
    createStationDD();    
}
/***********************************************************
 * get station information
 ***********************************************************/
var stationInfo = new Array();  
function getStationInfo()
{
    stationInfo.length = 0;
    var stationsElement = xmlDoc.getElementsByTagName("station");
    for (var i = 0; i < stationsElement.length; i++)
    {
        //window.prompt("",stationsElement.item(i).attributes(nameIX).value+"="+System.Gadget.document.parentWindow.lastStation);
        if(stationsElement.item(i).attributes(nameIX).value == System.Gadget.document.parentWindow.lastStation)
        {
            stationInfo[nameIX] = stationsElement.item(i).attributes(nameIX).value;
            stationInfo[genereIX] = stationsElement.item(i).attributes(genereIX).value;
            
            
            stationInfo[colorIX] = stationsElement.item(i).attributes(colorIX).value;
            stationInfo[mediaUrlIX] = stationsElement.item(i).attributes(mediaUrlIX).value;
            stationInfo[webIX] = stationsElement.item(i).attributes(webIX).value;
            
            // old versions
            if(stationInfo[colorIX] == "white")
            {
                stationInfo[colorIX] = "gray"; 
            }
            
                   
            stationInfo[bookmarkIX] = stationsElement.item(i).attributes(bookmarkIX).value;
            stationInfo[notesIX] = stationsElement.item(i).attributes(notesIX).value;
            stationInfo[cityIX] = stationsElement.item(i).attributes(cityIX).value;
            
            break;
        }    
    }
}
/***********************************************************
 * add a station
 ***********************************************************/
function addStation()
{
   var error = false;
   var errorText = "";
    
   var myRegxp = /[^0-9a-zA-Z_+ .-]/;
   
   if(!document.all("stationValue").value)
   {
    error = true;
    errorText += System.Gadget.document.parentWindow.DICT_Station + ": " +
                System.Gadget.document.parentWindow.DICT_Missing + "<br />";
   }    
   else if (myRegxp.test(document.all("stationValue").value))
   { 
        error = true;
        errorText += System.Gadget.document.parentWindow.DICT_Station + ": " +
                    System.Gadget.document.parentWindow.DICT_Invalid + "<br />";
   } 
     
   if(!document.all("genereValue").value)
   {
    error = true;
    errorText += System.Gadget.document.parentWindow.DICT_Genere + ": " +
                System.Gadget.document.parentWindow.DICT_Missing + "<br />";
   }    
   else if (myRegxp.test(document.all("genereValue").value))
   { 
        error = true;
        errorText += System.Gadget.document.parentWindow.DICT_Genere + ": " +
                    System.Gadget.document.parentWindow.DICT_Invalid + "<br />";
   }   
   
   if(error)
   {
        showMsgDIV(errorText);
        return;
   }
   var node = xmlDoc.selectSingleNode("//root/stations");
   var newel=xmlDoc.createElement('station');
   var newatt;
   // ************ DO NOT CHANGE THE ATTRIBUTES ORDERS *************
 
        newatt=xmlDoc.createAttribute("name");
        newatt.value = document.all("stationValue").value;
        newel.setAttributeNode(newatt);

        newatt=xmlDoc.createAttribute("genere");
        newatt.value = document.all("genereValue").value;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("color");
        newatt.value = document.all("colorDD").value;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("mediaurl");
        newatt.value = document.all("mediaurlValue").value;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("weburl");
        newatt.value = document.all("weburlValue").value;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("bookmarks");   
        if(document.all("showMarkedBX").checked == true)
                newatt.value = "true";
        else     
                newatt.value = "false";
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("notes");
        newatt.value = document.all("notesValue").value;
        newel.setAttributeNode(newatt);
   
        newatt=xmlDoc.createAttribute("city");
        newatt.value = document.all("cityValue").value;
        newel.setAttributeNode(newatt);
  
        node.appendChild(newel);
      
        xmlDoc.save(dbPath);
   
        System.Gadget.Settings.write("lastStation", document.all("stationValue").value);
        System.Gadget.document.parentWindow.lastStation = document.all("stationValue").value;
        System.Gadget.document.parentWindow.stationName.innerText = document.all("stationValue").value;  
   
        System.Gadget.document.parentWindow.lastStream = document.all("mediaurlValue").value;
   
        if(System.Gadget.document.parentWindow.isRunning)
        {
                if(document.all("mediaurlValue").value)
                {
                    System.Gadget.document.parentWindow.MediaPlayer.Stop();
                    System.Gadget.document.parentWindow.MediaPlayer.Open(document.all("mediaurlValue").value);
                    System.Gadget.document.parentWindow.MediaPlayer.Play();
                }
                else
                {
                    System.Gadget.document.parentWindow.MediaPlayer.Stop();
                    System.Gadget.document.parentWindow.isRunning = false;
                    document.all("powerButton").value = System.Gadget.document.parentWindow.DICT_On; 
                    document.all("equalizer").src = "../images/equalizer_off.png";
                }
            
       }
   System.Gadget.document.parentWindow.flyout(3);     
    
}
/***********************************************************
 * update a station
 ***********************************************************/
function updateStation()
{
   var error = false;
   var errorText = "";
   
    
   var myRegxp = /[^0-9a-zA-Z_+ .-]/;
    
   if(!document.all("genereValue").value)
   {
    error = true;
    errorText += System.Gadget.document.parentWindow.DICT_Genere + ": " +
                System.Gadget.document.parentWindow.DICT_Missing + "<br />";
   }    
   else if (myRegxp.test(document.all("genereValue").value))
   { 
        error = true;
        errorText += System.Gadget.document.parentWindow.DICT_Genere + ": " +
                    System.Gadget.document.parentWindow.DICT_Invalid + "<br />";
   } 
   
  if(error)
   {
        showMsgDIV(errorText);
        return;
   }
  
   
   var node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + document.all("stationValue").value + "']");
   node.attributes(genereIX).value = document.all("genereValue").value;
   node.attributes(colorIX).value = document.all("colorDD").value;
   node.attributes(mediaUrlIX).value = document.all("mediaurlValue").value;
   node.attributes(webIX).value = document.all("weburlValue").value;
   
   if(document.all("showMarkedBX").checked == true)
        node.attributes(bookmarkIX).value = "true";
   else     
        node.attributes(bookmarkIX).value = "false";
   node.attributes(notesIX).value = document.all("notesValue").value;
   node.attributes(cityIX).value = document.all("cityValue").value;        
      
   xmlDoc.save(dbPath);
   
   
   System.Gadget.Settings.write("lastStream", document.all("mediaurlValue").value);   
   System.Gadget.document.parentWindow.lastStream = document.all("mediaurlValue").value;
   
   if(System.Gadget.document.parentWindow.isRunning)
   {
        if(document.all("mediaurlValue").value)
        {
            System.Gadget.document.parentWindow.MediaPlayer.Stop();
            System.Gadget.document.parentWindow.MediaPlayer.Open(document.all("mediaurlValue").value);
            System.Gadget.document.parentWindow.MediaPlayer.Play();
        }
        else
        {
            System.Gadget.document.parentWindow.MediaPlayer.Stop();
            System.Gadget.document.parentWindow.isRunning = false;
            document.all("powerButton").value = System.Gadget.document.parentWindow.DICT_On; 
            document.all("equalizer").src = "../images/equalizer_off.png";
        }
            
   }
   System.Gadget.document.parentWindow.flyout(3);
   
}
/***********************************************************
 * rename a station
 ***********************************************************/
function renameStation()
{
   var error = false;
   var errorText = "";
   
    
   var myRegxp = /[^0-9a-zA-Z_+ .-]/;
    
   
   if(!document.all("newStationValue").value)
   {
    error = true;
    errorText += System.Gadget.document.parentWindow.DICT_Newname + ": " +
                System.Gadget.document.parentWindow.DICT_Missing+ "<br />";
   }    
   else if (myRegxp.test(document.all("newStationValue").value))
   { 
        error = true;
        errorText += System.Gadget.document.parentWindow.DICT_Newname + ": " +
                    System.Gadget.document.parentWindow.DICT_Invalid + "<br />";
   } 
   
   
   if(error)
   {
        showMsgDIV(errorText);
        return;
   } 
   
   var node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + document.all("stationValue").value + "']");
   node.attributes(nameIX).value = document.all("newStationValue").value;      
   xmlDoc.save(dbPath);
   
   System.Gadget.Settings.write("lastStation", document.all("newStationValue").value);
   System.Gadget.document.parentWindow.lastStation = document.all("newStationValue").value;
   System.Gadget.document.parentWindow.stationName.innerText = document.all("newStationValue").value;  

    System.Gadget.document.parentWindow.flyout(3);
}
/***********************************************************
 * delete a station
 ***********************************************************/
function deleteStation()
{
    var node = xmlDoc.selectSingleNode("//root/stations/station[@name='" + document.all("stationValue").value + "']");
    node.parentNode.removeChild(node);
    xmlDoc.save(dbPath);    
    
   System.Gadget.Settings.write("lastStation", "");
   System.Gadget.document.parentWindow.lastStation = "";
   System.Gadget.Settings.write("lastStream", "");
   System.Gadget.document.parentWindow.lastStream = "";
   System.Gadget.document.parentWindow.stationName.innerText = "";  
   
   if(System.Gadget.document.parentWindow.isRunning)
   {
        System.Gadget.document.parentWindow.MediaPlayer.Stop(); 
        System.Gadget.document.parentWindow.isRunning = false;       
   } 
   
}
/***********************************************************
 * split long text for output
 ***********************************************************/
function splitLongText(text)
{
    var leftSide = text.substr(0,40);
    var lenge = text.length - 40;
    var rightSide = text.substr(40,lenge);
    text = leftSide + "\n" + rightSide;
    return text;
}
/*-----------------------------------------------------
 * Clear and reload the colorDD
 *-----------------------------------------------------*/
function buildColorDD()
{
   
   var colorNames = new Array(System.Gadget.document.parentWindow.DICT_black,System.Gadget.document.parentWindow.DICT_red,System.Gadget.document.parentWindow.DICT_green,System.Gadget.document.parentWindow.DICT_blue,System.Gadget.document.parentWindow.DICT_yellow,System.Gadget.document.parentWindow.DICT_gray);
   var colorValues = new Array("black","red","green","blue","yellow","gray");
   
    for (i = 0; i < colorNames.length; i++)
    {
        var optn = document.createElement("OPTION");
        optn.text = colorNames[i];
        optn.value = colorValues[i];
        document.all("colorDD").options.add(optn);
        document.all("colorDD").options[i].style.color=colorValues[i];
        if(colorValues[i] == stationInfo[colorIX])
        {
            document.all("colorDD").options[i].selected=true;
        }
    }
}    
/***********************************************************
 * Visit the stations website
 ***********************************************************/
function browseURL()
{
    var load = window.open(""+stationInfo[webIX],"Radio",'left=20,top=20,width=800,height=600,toolbar=1,resizable=1,scrollbars=1');
}


function showMsgDIV(text)
{
        var inner = document.all("msgDIV").innerHTML; 
        inner = inner.replace("§TEXT§",text);
        document.all("msgDIV").style.visibility="visible";
        document.all("msgDIV").innerHTML = inner;
        document.all("msgButton").value = System.Gadget.document.parentWindow.DICT_Back;
}